#include <windows.h>
#include <Commctrl.h>
#include <stdio.h>
#include <string.h>
#include <shlobj.h>

#include "resource.h"
#include "settings.h"

#ifndef MAX_PATH
#define   MAX_PATH 2048
#endif


//  Function prototypes -------------------------

int CALLBACK RBDlgProc(HWND, UINT, WPARAM, LPARAM) ;
void init() ;
void get_file(int ID, char * mask);
void init_pdialog(bool is_rb);
bool launch_app();
bool launch_help();

// Globals --------------------------------------
HWND	 hwnd = 0 ;
Settings s;


int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
			 PSTR szCmdLine, int iCmdShow) {
	
	MSG	 msg ;

	InitCommonControls();

	s.init();

	char* x = MAKEINTRESOURCE(IDD_DIALOG_MAIN );
	hwnd = CreateDialog(hInstance, x, NULL, RBDlgProc);

	init();
	
	ShowWindow (hwnd, iCmdShow) ;
	UpdateWindow (hwnd) ;

	
	do {
		if (PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE)) {
			if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE)) {
				if (msg.message != WM_QUIT) {
					TranslateMessage (&msg) ;
					DispatchMessage  (&msg) ;
				}
			}
		} else {
			//ToDo, interject status info
			Sleep(10);
		}
	} while (msg.message != WM_QUIT) ;

	s.save_settings();

	return 1 ;
}

//  WndProc -------------------------------------
int CALLBACK RBDlgProc(HWND hwnd, UINT message, 
						WPARAM wParam, LPARAM lParam) {
	static char tstr[MAX_PATH];
	static bool init = false, init2 = false;
	int tmp;

	switch (message) {
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDC_EMU_EDIT:
			if(HIWORD(wParam) == EN_UPDATE) {
				GetDlgItemText(hwnd,IDC_EMU_EDIT,tstr,MAX_PATH);
				if(s.emuPath) delete [] s.emuPath;
				s.emuPath = new char[sizeof(tstr)+1];
				strcpy(s.emuPath,tstr);
			}
			break;
		case IDC_ROM_EDIT:
			if(HIWORD(wParam) == EN_UPDATE) {
				GetDlgItemText(hwnd,IDC_ROM_EDIT,tstr,MAX_PATH);
				if(s.romPath) delete [] s.romPath;
				s.romPath = new char[sizeof(tstr)+1];
				strcpy(s.romPath,tstr);
			}
			break;
		case IDC_FSKIP_EDIT:
			if(!init) {
				SetDlgItemInt(hwnd,IDC_FSKIP_EDIT,s.fSkip,false);
				init = true;
			} else if(HIWORD(wParam) == EN_UPDATE)
				s.fSkip = GetDlgItemInt(hwnd,IDC_FSKIP_EDIT,NULL,false);
			break;
		case IDC_SCL_EDIT:
			if(!init2) {
				SetDlgItemInt(hwnd,IDC_SCL_EDIT,s.scale,false);
				init2 = true;
			} else if(HIWORD(wParam) == EN_UPDATE) {
				tmp = GetDlgItemInt(hwnd,IDC_SCL_EDIT,NULL,false);
				if(tmp<1) {
					s.scale = 1;
					SetDlgItemInt(hwnd,IDC_SCL_EDIT,s.scale,false);
				} else if(tmp>4) {
					s.scale = 4;
					SetDlgItemInt(hwnd,IDC_SCL_EDIT,s.scale,false);
				} else {
					s.scale = tmp;
				}
			}
			break;
		case IDC_DSP_COMBO:
			if(HIWORD(wParam) == CBN_SELCHANGE)
				s.dspMode = SendMessage((HWND)lParam,CB_GETCURSEL,0,0);
			break;
		case IDC_3D_COMBO:
			if(HIWORD(wParam) == CBN_SELCHANGE) {
				s.threedMode = SendMessage((HWND)lParam,CB_GETCURSEL,0,0);
				init_pdialog(1 == s.threedMode);
			}
			break;
		case IDC_PAL_COMBO:
			if(HIWORD(wParam) == CBN_SELCHANGE)
				s.pallet = SendMessage((HWND)lParam,CB_GETCURSEL,0,0);
			break;
		case IDC_KEY_COMBO:
			if(HIWORD(wParam) == CBN_SELCHANGE)
				s.keyMap = SendMessage((HWND)lParam,CB_GETCURSEL,0,0);
			break;
		
		case IDC_SWP_CHECK:
			s.swap = (bool)SendMessage ((HWND) lParam, BM_GETCHECK, 0, 0);
			break;
		case IDC_LTHACK_CHECK:
			s.timmerHack = (bool)SendMessage ((HWND) lParam, BM_GETCHECK, 0, 0);
			break;
		case IDC_VFHACK_CHECK:
			s.vfHack = (bool)SendMessage ((HWND) lParam, BM_GETCHECK, 0, 0);
			break;
		case IDC_DBG_CHECK:
			s.debug = (bool)SendMessage ((HWND) lParam, BM_GETCHECK, 0, 0);
			break;
		
		case IDC_THR_CHECK:
			s.nothrtl = (bool)SendMessage ((HWND) lParam, BM_GETCHECK, 0, 0);
			break;
		case IDC_STS_CHECK:
			s.status = (bool)SendMessage ((HWND) lParam, BM_GETCHECK, 0, 0);
			break;
		case IDC_DIS_CHECK:
			s.disasm = (bool)SendMessage ((HWND) lParam, BM_GETCHECK, 0, 0);
			break;

		case IDC_CON_CHECK:
			s.stdOut = (bool)SendMessage ((HWND) lParam, BM_GETCHECK, 0, 0);
			break;

		case IDC_HELP_BUTTON:
			launch_help();
			break;
		case IDC_LAUNCH_BUTTON:
			launch_app();
			break;

		case IDC_EMU_BUTTON:
			get_file(IDC_EMU_EDIT, "*.exe\0*.exe\0all files\0*.*\0\0");
			break;

		case IDC_ROM_BUTTON:
			get_file(IDC_ROM_EDIT, "*.vb\0*.vb\0all files\0*.*\0\0");
			break;
			
		default:
			break;
		}
		
		break;

	case WM_PAINT:
		return FALSE;

	case WM_CLOSE:
		// since the dialog is non-modal, we destroy it instead of 
		//  calling EndDialog
		DestroyWindow (hwnd) ;
		return TRUE ;
	case WM_DESTROY:
		PostQuitMessage(0) ;
		return TRUE ;
	}

	return FALSE;
}

void get_file(int ID, char * mask) {
	OPENFILENAME ofn;
	char tstr[MAX_PATH];

	memset(&ofn,0,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof (OPENFILENAME);

	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = TEXT(mask);
	GetDlgItemText(hwnd,ID,tstr,MAX_PATH);
	ofn.lpstrFile = tstr;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrTitle = NULL;

	if(GetOpenFileName(&ofn)) {
		if(strlen(tstr)<1) return;
		SetDlgItemText(hwnd,ID,tstr);
	}
}

void init_pdialog(bool is_rb) {
	HWND ht;

	ht = GetDlgItem(hwnd,IDC_PAL_COMBO);

	//remove old strings
	SendMessage(ht, CB_DELETESTRING, 0, NULL);
	SendMessage(ht, CB_DELETESTRING, 0, NULL);
	SendMessage(ht, CB_DELETESTRING, 0, NULL);
	
	if(!is_rb) {
		SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Normal");
		SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Red");
	} else {
		SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Red-Blue");
		SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Red-Green");
		SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Red-Blue/Green");
	}
	SendMessage(ht, CB_SETCURSEL, s.pallet, 0);
}

void init() {
	HWND ht;

	//Initialize the dropdown boxes
	ht = GetDlgItem(hwnd,IDC_DSP_COMBO);
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Frame");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"320x200");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"640x480");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"800x600");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"1024x768");
	SendMessage(ht, CB_SETCURSEL, s.dspMode, 0);

	ht = GetDlgItem(hwnd,IDC_3D_COMBO);
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Normal");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Red Blue");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Interlaced");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Over under");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Side");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"CyberScope");
	SendMessage(ht, CB_SETCURSEL, s.threedMode, 0);

	init_pdialog(1 == s.threedMode);

	ht = GetDlgItem(hwnd,IDC_KEY_COMBO);
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Default");
	SendMessage(ht, CB_ADDSTRING, 0, (LPARAM)"Alternate");
	SendMessage(ht, CB_SETCURSEL, s.keyMap, 0);


	//set edit boxes
	SetDlgItemText(hwnd,IDC_EMU_EDIT, s.emuPath);
	SetDlgItemText(hwnd,IDC_ROM_EDIT, s.romPath);

	SetDlgItemInt(hwnd,IDC_FSKIP_EDIT, s.fSkip, false);
	SetDlgItemInt(hwnd,IDC_SCL_EDIT, s.scale, false);

	//set check boxes
	SendMessage (GetDlgItem(hwnd,IDC_SWP_CHECK),
			BM_SETCHECK, (WPARAM)s.swap, 0);
	SendMessage (GetDlgItem(hwnd,IDC_LTHACK_CHECK),
			BM_SETCHECK, (WPARAM)s.timmerHack, 0);
	SendMessage (GetDlgItem(hwnd,IDC_VFHACK_CHECK),
			BM_SETCHECK, (WPARAM)s.vfHack, 0);
	SendMessage (GetDlgItem(hwnd,IDC_DBG_CHECK),
			BM_SETCHECK, (WPARAM)s.debug, 0);
	SendMessage (GetDlgItem(hwnd,IDC_THR_CHECK),
			BM_SETCHECK, (WPARAM)s.nothrtl, 0);
	SendMessage (GetDlgItem(hwnd,IDC_STS_CHECK),
			BM_SETCHECK, (WPARAM)s.status, 0);
	SendMessage (GetDlgItem(hwnd,IDC_DIS_CHECK),
			BM_SETCHECK, (WPARAM)s.disasm, 0);
	SendMessage (GetDlgItem(hwnd,IDC_CON_CHECK),
			BM_SETCHECK, (WPARAM)s.stdOut, 0);
}

bool launch_app() {
	char arg_str[512];
	char * dspStr[] = {"frame", "320", "640", "800", "1024"};
	char * dsmStr[] = {"normal", "red_blue", "interlace", "over_under", "side", "cscope"};
    char * palStr[] = {"normal", "red", "rb", "rg", "rbg"};

	sprintf(arg_str,"%s -display %s -dspmode %s -frmskp %d -sclscr %d " \
		"-pallet %s %s %s %s %s %s %s %s %s %s",
		s.romPath,
		dspStr[s.dspMode],
		dsmStr[s.threedMode],
		s.fSkip,
		s.scale,
		palStr[(s.threedMode ==1)?s.pallet+2:s.pallet],
		(s.swap)?"-flip":"",
		(s.timmerHack)?"-ltimmer":"",
		(s.vfHack)?"-vfhack":"",
		(s.debug)?"-debug":"",
		(s.disasm)?"-disasm":"",
		(s.stdOut)?"-stdout":"",
		(s.keyMap == 1)?"-altkbd":"",
		(s.nothrtl)?"-nothrtl":"",
		(s.status)?"-status":"");
	
	ShellExecute(hwnd, "open",
    s.emuPath,		//exe
    arg_str,		//args
    s.progPath,		//directory
    SW_SHOWNORMAL);

	return true;
}

bool launch_help() {
	//todo, return sucsess or failure
	ShellExecute(hwnd, "open",
    "help\\help.html",
    NULL,//args
    s.progPath, //directory
    SW_SHOWNORMAL);

	return true;
}

